' FileName: WCFAImpt.Bas
' Date: 7/3/2014
' Author: Ben Ritchey
' Description: Wildcat File Area Import utility

#COMPILER PBCC 5
#COMPILE EXE
#DIM ALL

  TYPE FARecord
    VLIDESC AS STRING *1
    FADESC AS STRING *30
    VLIPATH AS STRING *1
    FAPATH AS STRING *87
  END TYPE

FUNCTION PBMAIN () AS LONG

LOCAL MONTHTAB() AS STRING
LOCAL EOTIMEOUT AS DOUBLE
LOCAL ETO, FIRSTFA, LASTFA, NEXTFA, FACOUNT AS DOUBLE
LOCAL PNAME AS STRING
LOCAL A AS STRING
LOCAL B AS LONG
LOCAL Z AS STRING
LOCAL AA, AB, DE AS INTEGER
LOCAL L, M AS INTEGER
LOCAL AC, FAREA(), FAFILE, FAFPATH, FAFDESC AS STRING
LOCAL CX, CY AS INTEGER

' Code Starts Here * * * * * * * *
  CLS: ON ERROR GOTO INTERROR
  DIM MONTHTAB(12)
  EOTIMEOUT=TIMER+60
100 PNAME=" Wildcat! File Area Import "
  FOR L=1 TO 12
    MONTHTAB(L)=READ$(L)
   NEXT L

200  COLOR 11: LOCATE 1,1
  COLOR 7: LOCATE 1, INT((80 - LEN(PNAME$)) / 2): PRINT PNAME$;
  COLOR 7: LOCATE 1, 2: PRINT " WCFAImpt v1.0.B ";
    LOCATE 2,3: PRINT " {c} 2015  BJr ";
'    LOCATE 25,60: PRINT " Serial #";
'    COLOR 15: PRINT "WFA151B100";  '                       *** Serial # ***
   LOCATE 3,1

300  Z=Z+MONTHTAB(VAL(MID$(DATE$,1,2)))+STR$(VAL(MID$(DATE$,4,2)))
  A="th": AA=VAL(MID$(DATE$,4,2))
  IF AA=1 OR AA=21 OR AA=31 THEN A="st"
  IF AA = 2 OR AA = 22 THEN A = "nd"
  IF AA = 3 OR AA = 23 THEN A = "rd"
  Z = Z + A + ", " + MID$(DATE$, 7, 4): AA=79-LEN(Z)
  LOCATE 1,AA: PRINT Z;

400  GOSUB DOTOD

1000  LOCATE 3, 1: COLOR 3
GETFAN:
  Z="Enter FIRST File Area NUMBER to OVERLAY (1 TO 32,760): ": GOSUB PROMPT

  FIRSTFA=VAL(A)
  IF FIRSTFA<1 OR FIRSTFA>32760 THEN
BADFFA:
    BEEP: Z="ERROR: Invalid Area Number ["+STR$(FIRSTFA)+"], re-Enter!"
    GOSUB MESSAGE
    GOTO GETFAN
  END IF

  OPEN "FILEAREA.DAT" FOR RANDOM AS #2 LEN=119
  LASTFA=LOF(2)/119
  IF LASTFA<FIRSTFA THEN
    Z="ERROR: FILEAREA.DAT only contains"+STR$(LASTFA)+" Records(Areas)."
    GOSUB MESSAGE
    GOTO BADFFA
  END IF

  DIM FAREA AS FARecord

  Z="Enter File Name of Input file (I.E. FAREAS.TXT): ": GOSUB PROMPT
  IF A="" THEN A="FAREAS.TXT"
  FAFILE=A

  OPEN FAFILE FOR INPUT AS #1

  NEXTFA=FIRSTFA
  DE=0
  OPEN "WCFAIMPT.ERR" FOR OUTPUT AS #3

DOIT:
  IF EOF(1) THEN GOTO DIDIT
  LINE INPUT #1,A: IF A="" THEN GOTO DOIT

  M=LEN(A): FOR L=1 TO M  ' TRIM LEADING SPACES
    IF MID$(A,1,1)=" " THEN A=MID$(A,2) ELSE L=M
  NEXT L
  FOR L=M TO 1 STEP -1  ' TRIM TRAILING SPACES
    IF MID$(A,LEN(A),1)=" " THEN A=MID$(A,1,LEN(A)-1) ELSE L=1
  NEXT L

  GET(2), NEXTFA, FAREA
  FAREA.VLIDESC=CHR$(0): FAREA.VLIPATH=CHR$(0)
  FAREA.FADESC=STRING$(30,0): FAREA.FAPATH=STRING$(87,0)

  L=INSTR(A," ")
  IF L=0 THEN
     IF LEN(A)>87 THEN Z=A: GOSUB DATAERR: A=MID$(A,1,87)
     FAREA.VLIPATH=CHR$(LEN(A)): MID$(FAREA.FAPATH,1,LEN(A))=A
     FAREA.VLIDESC=CHR$(16): MID$(FAREA.FADESC,1)="(no description)"
     GOTO PUTFA
  END IF

  FAFPATH=MID$(A,1,L-1): FAFDESC=MID$(A,L+1)

  M=LEN(FAFDESC)
  FOR L=1 TO M  ' MORE LEADING  SPACES?
  IF MID$(FAFDESC,1,1)=" " THEN FAFDESC=MID$(FAFDESC,2) ELSE L=M
  NEXT L

  IF FAFDESC="" OR FAFDESC=" " THEN FAFDESC="(no description)"

  IF LEN(FAFDESC)>30 THEN Z=FAFDESC: GOSUB DATAERR: FAFDESC=MID$(FAFDESC,1,30)
  IF LEN(FAFPATH)>87 THEN Z=FAFPATH: GOSUB DATAERR: FAFPATH=MID$(FAFPATH,1,87)
  FAREA.VLIDESC=CHR$(LEN(FAFDESC))
  FAREA.VLIPATH=CHR$(LEN(FAFPATH))
  MID$(FAREA.FADESC,1,LEN(FAFDESC))=FAFDESC
  MID$(FAREA.FAPATH,1,LEN(FAFPATH))=FAFPATH

PUTFA:
  PUT(2), NEXTFA, FAREA
  FACOUNT=FACOUNT+1
  PRINT NEXTFA;"  ";
  IF FAREA.VLIDESC="" THEN PRINT FAREA.FAPATH ELSE PRINT FAREA.FADESC
  NEXTFA=NEXTFA+1
  GOTO DOIT

DIDIT:
  CLOSE: BEEP
  PRINT
  Z="File FILEAREA.DAT has been updated successfully.": GOSUB MESSAGE
  Z="  Total Records processed ="+STR$(FACOUNT): GOSUB MESSAGE
  Z="  Last Area Written ="+STR$(NEXTFA-1): GOSUB MESSAGE
  IF DE=1 THEN Z="*** See file WCFAIMPT.ERR for Errors ***": GOSUB MESSAGE
  Z="    Press any key to continue ...": GOSUB PROMPT

REM  ERROR(123)
  GOTO FINISHED

DATAERR:
  PRINT #3,"*ERROR: Area = ";NEXTFA;" [";Z;"] is invalid."
  DE=1
  RETURN
PROMPT:
  COLOR 7: PRINT Z;: COLOR 15: INPUT A
  COLOR 3
 RETURN
MESSAGE:
  PRINT Z
 RETURN
DOTOD:
  CX=CURSORX: CY=CURSORY
  Z=TIME$: AA=VAL(MID$(TIME$, 1, 2))
  IF AA>11 THEN Z=Z+" Pm" ELSE Z=Z+" Am"
  IF AA>12 THEN
    A=MID$(STR$(AA-12),2)
    IF LEN(A)=1 THEN A=" "+A
    MID$(Z,1)=A
  END IF
  LOCATE 2,67: PRINT Z;
  LOCATE CY,CX
 RETURN

INTERROR:
  AB=ERL: AC=ERROR$(ERR): AA=ERRCLEAR

10000 PRINT

  BEEP
  COLOR 14
  PRINT "  Internal Error: ";
  COLOR 3: PRINT "Line";
  COLOR 15: PRINT AB;: COLOR 3: PRINT "  Code";
  COLOR 15: PRINT AA;: COLOR 3: PRINT " = ";
  COLOR 15: PRINT AC
  COLOR 3: PRINT "  Press any key ...";

  A="": WHILE A="": A=INKEY$: WEND
'  ON ERROR GOTO 0 ' Run-time use!
  RESUME FINISHED

' *** Debug
  BEEP
  PRINT "Ok": A="": WHILE A="": A=INKEY$: WEND
' *** Debug

FINISHED:
55000 COLOR 7: PRINT
  ON ERROR GOTO EXITOR
  Z="": ETO=0
  LOCATE ,13
  PRINT " -=:{  Touch any key to Abort one minute Window }:=- "

    DO
      Z=INKEY$: IF LEN(Z)>0 THEN EXIT DO
      IF TIMER>=ETO+1 THEN
        ETO=TIMER
        IF INT(EOTIMEOUT-ETO)>0 THEN PRINT INT(EOTIMEOUT-ETO);
        GOSUB DOTOD
      END IF
    LOOP UNTIL TIMER>EOTIMEOUT

55500  PRINT
  CLOSE
  SHELL "CLS"
EXITOR:

REM Month Table Data
DATA January, February, March, April, May, June
DATA July, August, September, October, November, December

END FUNCTION

' End of PBSKEL.Bas

